=== debian/changelog ===
kf5-messagelib (4:20.08.3-5) unstable; urgency=high

  [ Norbert Preining ]
  * Backport upstream fix for CVE-2021-31855.

 -- Sandro Knauß <hefee@debian.org>  Wed, 23 Jun 2021 12:48:07 +0200

kf5-messagelib (4:20.08.3-4) unstable; urgency=medium

  * Fix broken patch series file (Closes: #986452).

 -- Sandro Knauß <hefee@debian.org>  Tue, 06 Apr 2021 16:22:38 +0200

kf5-messagelib (4:20.08.3-3) unstable; urgency=medium

  * Add upstream patch to show correct icons (Closes: #964963).
  * Add upstream patch to reenable contact preferences again
    (Closes: #986404).

 -- Sandro Knauß <hefee@debian.org>  Mon, 05 Apr 2021 13:06:12 +0200

kf5-messagelib (4:20.08.3-2) unstable; urgency=medium

  * Add upstream patch to not break the signature of mails.
  * Add upstream patch to sign and encrypt protected headers.

 -- Sandro Knauß <hefee@debian.org>  Mon, 01 Feb 2021 20:34:19 +0100

kf5-messagelib (4:20.08.3-1) unstable; urgency=medium

  [ Sandro Knauß ]
  * Bump Standards-Version to 4.5.1 (No changes needed).
  * New upstream release (20.08.3).
  * Update build-deps and deps with the info from cmake.
  * Update patch hunks.
  * Add upstream patch to fix segfault for encrypted mails.
  * Minimize the upstream GPG signing key.

 -- Sandro Knauß <hefee@debian.org>  Wed, 16 Dec 2020 01:50:33 +0100

kf5-messagelib (4:20.08.2-2) unstable; urgency=medium

  * Team upload to unstable.

 -- Sandro Knauß <hefee@debian.org>  Tue, 20 Oct 2020 00:09:32 +0200

kf5-messagelib (4:20.08.2-1) experimental; urgency=medium

  [ Sandro Knauß ]
  * New upstream release (20.08.2).
  * Update build-deps and deps with the info from cmake.
  * Update Homepage link to point to new invent.kde.org
  * Update field Source in debian/copyright to invent.kde.org move.
  * Update repository related entries to metadata file.
  * Add Bug-* entries to metadata file.
  * Remove not needed Build-Depends.
  * Update copyright file for 20.08.

 -- Sandro Knauß <hefee@debian.org>  Fri, 16 Oct 2020 00:53:18 +0200

kf5-messagelib (4:20.04.1-2) unstable; urgency=medium

  * Team upload.
  * Switch from dhmk to the dh sequencer:
    - invoke the dh sequencer using the kf5 addon
    - call the right debhelper command instead of $(overridden_command)
    - manually force the generation of the substvars for the strict shlibs
      handling
  * There is grantlee 5.2 in Debian, so:
    - drop patch lower_grantlee_dep.patch
    - bump the libgrantlee5-dev build dependency to 5.2
  * Unregister the old /etc/xdg/messagelib.categories,
    /etc/xdg/messagelib.renamecategories, and
    /etc/xdg/messageviewer_header_themes.knsrc conffiles.
  * Update install files.

 -- Pino Toscano <pino@debian.org>  Sun, 16 Aug 2020 21:30:17 +0200

kf5-messagelib (4:20.04.1-1) unstable; urgency=medium

  [ Sandro Knauß ]
  * New upstream release (20.04.1).
  * Update build-deps and deps with the info from cmake.
  * Remove not needed Build-Depends.
  * Lower Grantlee dependency to 5.1.

 -- Sandro Knauß <hefee@debian.org>  Wed, 27 May 2020 00:00:56 +0200

kf5-messagelib (4:20.04.0-1) experimental; urgency=medium

  [ Sandro Knauß ]
  * Update watch file to the new release-service location.
  * Bump compat level to 13.
  * Bump Standards-Version to 4.5.0 (No changes needed).
  * Add Rules-Requires-Root field to control.
  * New upstream release (20.04.0).
  * Update build-deps and deps with the info from cmake.
  * Lower Grantlee dependency to 5.1.
  * Update patch hunks.
  * Update install files as files were renamed and deleted.
  * Wrap long lines in changelog entries: 4:16.04.3-2.
  * Update renamed lintian tag names in lintian overrides.
  * Set fields Upstream-Name, Upstream-Contact in debian/copyright.
  * Remove obsolete fields Contact, Name from debian/upstream/metadata
    (already present in machine-readable debian/copyright).
  * Enable hardening all.
  * Update copyright file.
  * Remove not needed lintian-overrides.

 -- Sandro Knauß <hefee@debian.org>  Wed, 13 May 2020 12:24:10 +0200
